From s-sender@utstat.toronto.edu Sat Oct 22 18:02:20 1994
Received: from utstat.toronto.edu (utstat.toronto.edu [128.100.73.1]) by biostat.mc.duke.edu (8.6.8.1/8.6.6) with SMTP id SAA24641 for <feh@biostat.mc.duke.edu>; Sat, 22 Oct 1994 18:02:17 -0400
Received: by utstat; Sat Oct 22 17:39 EDT 1994
Received: by vns601c.gsc.emr.ca; Sat, 22 Oct 94 17:41:18 EDT
Date: Sat, 22 Oct 94 17:34:16 EDT
Message-ID: <Rxf8+LJMeia@vns601c.gsc.emr.ca>
From: garrett@gsc.emr.ca
To: s-news@utstat.toronto.edu
Cc: ashar@kernel.uwrl.usu.edu
Subject: Log scaled box-plots
X-Incognito-SN: 100
X-Incognito-Format: VERSION=1.72a ENCRYPTED=NO
Status: RO

Ashish Sharma <ashar@kernel.uwrl.usu.edu> Wrote:
| 
| Please help. I suppose there must be some way of having logarithmic
| axes in the boxplot command without actually having to pass log 
| transformed values.

I was faced with this problem a little while ago, and somewhere in one  
of the manuals it tells you that  logarithmic axes are not possible.  My 
solution is below, it involves log transforming the data, but that is no 
inconveniance.  I aplogize for any inelegance, I am not a seasoned S 
function writer yet:

"rg.log.plot.factor"<-
function(x, y, xlab = deparse(substitute(x)), ylab = deparse(substitute(y)), 
na.rm = F)
{
	yy <- log10(y)
	yyrng <- range(yy)
	ylim <- c(floor(yyrng[1]), ceiling(yyrng[2]))
	nytck <- ylim[2] - ylim[1] + 1
	at <- dim(nytck)
	yt <- dim(nytck)
	ct <- dim(nytck)
	at[1] <- ylim[1]
	yt[1] <- 10^at[1]
	for(i in 2:nytck) {
		at[i] <- at[i - 1] + 1
		yt[i] <- yt[i - 1] * 10
	}
	ct <- as.character(yt)
	plot.factor(x, yy, xlab = xlab, ylab = ylab, axes = F, ylim = ylim)
	axis(2, at = at, labels = ct, srt = 90)
	box()
	invisible()
}

An example of the call is, assuming the data are in an attached data frame:

rg.log.plot.factor(SPM, Se, xlab="Soil Parent Material",
		ylab="Se (ppm) in <2 mm fraction of Surface Soil")

I hope this will save you some time.

While I am here - I have another task coming up for myself.  Plotting  what 
geoscientists and soil scientists call ternary, or triangular, diagrams.  If 
any one has a function to plot these I would be grateful  for a copy. 

Robert G. (Bob) Garrett
Applied Geochemistry Subdivision
Geological Survey of Canada
601 Booth St., Ottawa, Ontario K1A 0E8
Internet: garrett@gsc.emr.ca
Tel.: 613+995-4517   FAX: 613+996-3726



From s-sender@utstat.toronto.edu Sun Oct 23 22:58:21 1994
Received: from utstat.toronto.edu (utstat.toronto.edu [128.100.73.1]) by biostat.mc.duke.edu (8.6.8.1/8.6.6) with SMTP id WAA03150 for <feh@biostat.mc.duke.edu>; Sun, 23 Oct 1994 22:58:20 -0400
Received: by utstat; Sun Oct 23 22:42 EDT 1994
Received: by astro.ocis.temple.edu (5.61/25)
	id AA03916; Sun, 23 Oct 94 22:41:58 -0400
Date: Sun, 23 Oct 94 22:41:58 -0400
From: rmh@astro.ocis.temple.edu (Richard M. Heiberger)
Message-Id: <9410240241.AA03916@astro.ocis.temple.edu>
To: ashar@kernel.uwrl.usu.edu, s-news@utstat.toronto.edu
Subject: Re: Drawing boxplots with logarithmic axes.
Status: RO

The problem with logarithmic axes comes from the confidence limits for
the median in $conf.  These numbers are not guaranteed positive.
Hence logarithms of those quantities may be undefined.

To get the plot you want, you must check the confidence limits and suppress them
if negative.  Then transform $out, $stats, and $conf (if non-negative).
You must do this with the results of boxplot(... plot=F), and not with the
original data, as the definition of outliers is based on the scale of the data
given to boxplot().

x <- 10^(1:10)
zz <- boxplot(x, plot = F)
print(zz)
par(mfrow=c(3,1))
z1 <- bxp(zz)

zzl <- zz
zzl$out <- log(zz$out,10)
zzl$stats <- log(zz$stats,10)
zzl$conf <- log(zz$conf,10)
z2 <- bxp(zzl) # missing values not allowed: dumped

zzl$conf[] <- log(zz$stats[3],10)
z3 <- bxp(zzl)


