From yandell@stat.wisc.edu Tue Feb 15 12:06:20 1994
Received: from mercury.stat.wisc.edu (mercury.stat.wisc.edu [128.105.5.39]) by biostat.mc.duke.edu (8.6.4/8.6.4) with SMTP id MAA29912 for <feh@biostat.mc.duke.edu>; Tue, 15 Feb 1994 12:06:19 -0500
Date: Tue, 15 Feb 94 11:06:18 -0600
From: yandell@stat.wisc.edu (Brian Yandell)
Message-Id: <9402151706.AA29098@mercury.stat.wisc.edu>
Received: by mercury.stat.wisc.edu; Tue, 15 Feb 94 11:06:18 -0600
To: Frank Harrell <feh@biostat.mc.duke.edu>
In-Reply-To: <199402090300.WAA15682@biostat.mc.duke.edu>
Subject: remote sas in S
Content-Length: 239
X-Lines: 5
Status: RO

I have modified your sas.* commands in S to allow one to get the
contents of datasets located on other computers.  This was necessary
for my use here in teaching, and may have some broader appeal.  Are
you interested in seeing this?
Brian

From yandell@stat.wisc.edu Tue Feb 15 12:58:22 1994
Received: from mercury.stat.wisc.edu (mercury.stat.wisc.edu [128.105.5.39]) by biostat.mc.duke.edu (8.6.4/8.6.4) with SMTP id MAA00411 for <feh@biostat.mc.duke.edu>; Tue, 15 Feb 1994 12:58:14 -0500
Date: Tue, 15 Feb 94 11:58:09 -0600
From: yandell@stat.wisc.edu (Brian Yandell)
Message-Id: <9402151758.AA29824@mercury.stat.wisc.edu>
Received: by mercury.stat.wisc.edu; Tue, 15 Feb 94 11:58:09 -0600
To: Frank Harrell <feh@biostat.mc.duke.edu>
In-Reply-To: <199402151734.MAA22321@biostat2.mc.duke.edu>
Subject: Re: remote sas in S -- source
Content-Length: 14064
X-Lines: 397
Status: RO

rsas.contents <- function(...,macro.dir="/atlas3/splus/cmd",remote="atlas")
   sas.contents(...,macro.dir=macro.dir,remote=remote)
rsas.fget <- function(...,remote="atlas")
   sas.fget(...,remote=remote)
rsas.datasets <- function(...,remote="atlas")
   sas.datasets(...,remote=remote)
rsas.get <- function(...,macro.dir="/atlas3/splus/cmd",remote="atlas")
   sas.get(...,macro.dir=macro.dir,remote=remote)

sas.contents <- function(library, member, keep.log = T, log.file = "_temp_.log",
   macro = "sas_vars", macro.dir = unix("echo $SHOME/cmd"),
   clean.up = T, quiet = F, temp = tempfile("SaS"),remote="")
{
   sasin <- paste(temp, ".3", sep = "")
   sasout1 <- paste(temp, ".1", sep = "")
   file.exists <- function(name,remote) {
      cmd <- paste("test -f", name, "-o -d", name)
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(out = F, cmd) == 0
   }
   file.find <- function(name,remote) {
      cmd <- paste("ls ", paste(name, "*", collapse = " ",
         sep = ""), "2>/dev/null")
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(cmd)
   }
   file.is.dir <- function(name,remote) {
      cmd <- paste("test -d", name)
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(out = F, cmd) == 0
   }
   file.is.readable <- function(name,remote) {
      cmd <- paste("test -r", name)
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(out = F, cmd) == 0
   }
   file.cp.to <- function(name,remote) {
      if (remote != "")
         unix(paste("rcp ",name," ",remote,":",name,sep=""))
   }
   file.cp.from <- function(name,remote) {
      if (remote != "")
         unix(paste("rcp ",remote,":",name," ",name,sep=""))
   }
   if(length(sasin) != 1)
      stop("Illegal temporary file name")
   temp.files <- c(sasin, sasout1)
   if(!keep.log)
      temp.files <- c(temp.files, log.file)
   if(clean.up) {
      clean.cmd <- paste("rm -f", paste(temp.files, collapse = " "))
      if (remote != "")
         clean.cmd <- paste(clean.cmd,";","rsh",remote,clean.cmd,"; date")
      on.exit(unix(clean.cmd))
   }
   if(missing(member))
      stop("SAS member name is required")
   if(missing(library))
      stop("SAS library name is required")
   cat(paste("%include '", macro.dir, "/", macro, "';\n", sep = ""), file
       = sasin)
   if(library == "") {
      cat("%", macro, "(", member, " ,", sasout1, ");\n", file = 
         sasin, append = T, sep = "")
   }
   else {
      if(!file.is.dir(library,remote))
         stop(paste(sep = "", "library, \"", library, 
            "\", is not a Unix directory"))
      unix.file <- paste(sep = "", library, "/", member, ".ssd")
      unix.file2 <- file.find(unix.file,remote)
      if(!length(unix.file2)) {
         stop(paste(sep = "", "No Unix files, \"", unix.file, 
            "*\""))
      }
      else if(length(unix.file2) > 1)
         stop(paste(sep = "", "More than one file in, \"", 
            unix.file, "*\""))
      else unix.file <- unix.file2
      if(!file.is.readable(unix.file,remote)) {
         stop(paste(sep = "", 
            "You do not have read permission for Unix file, \"",
            file.name, "\""))
      }
      cat("libname temp '", library, "';\n", file = sasin, append = T,
         sep = "")
      cat("%", macro, "(temp.", member, " ,", sasout1, ");\n", file
          = sasin, append = T, sep = "")
   }
   cmd <- paste("sas", sasin, "-log", log.file)
   if (remote != "")
      cmd <- paste("rsh",remote,cmd)
   file.cp.to(sasin,remote)
   status <- unix(cmd, output = F)
   file.cp.from(log.file,remote)
   if(status != 0) {
      if(!quiet)
         unix(paste("less", log.file), out = F)
      stop(paste("SAS job failed with status", status))
   }
#
# Read in the variable information
#
   if(!file.exists(sasout1,remote)) {
      if(!quiet)
         unix(paste("less", log.file), out = F)
      stop("SAS output file not found")
   }
   file.cp.from(sasout1,remote)
   vars <- scan(sasout1, list(name = "", type = 0, length = 0, format = "",
      label = "", n = 0), multi.line = T, sep = "\022")   #
# Just return names and the common n
#
   attr(vars$name, "n") <- vars$n[1]
   vars$name
}

sas.datasets <- function(library,remote="")
{
   file.is.dir <- function(name,remote) {
      cmd <- paste("test -d", name)
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(out = F, cmd) == 0
   }
   if(!file.is.dir(library,remote))
      stop(paste(sep = "", "library, \"", library, 
         "\", is not a Unix directory"))
   if(remote != "")
      cmd <- paste("rsh",remote,"cd", library, "\";\"")
   else
      cmd <- paste("cd", library, ";")
   unix(paste(cmd,"ls *.ssd *.ssd0[12] 2>/dev/null | sed -e 's/\\.ssd$//' -e 's/\\.ssd01$//' -e 's/\\.ssd02$//'"))
}

sas.get <- function(library, member, variables = character(0), ifs = character(0), 
   format.library = library, id, dates = "sas", keep.log = T, log.file = 
   "_temp_.log", macro = "sas_get", macro.dir = unix("echo $SHOME/cmd"), 
   data.frame.out = exists("data.frame", mode = "function"), clean.up = T, 
   quiet = F, temp = tempfile("SaS"),remote="atlas")
{
   sasin <- paste(temp, ".3", sep = "")
   sasout1 <- paste(temp, ".1", sep = "")
   sasout2 <- paste(temp, ".2", sep = "")
   nvariables <- length(variables)
   varstring <- paste(variables, collapse = "\n ")
   ifs <- paste(ifs, collapse = ";\n ")
   file.exists <- function(name,remote) {
      cmd <- paste("test -f", name, "-o -d", name)
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(out = F, cmd) == 0
   }
   file.find <- function(name,remote) {
      cmd <- paste("ls ", paste(name, "*", collapse = " ",
         sep = ""), "2>/dev/null")
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(cmd)
   }
   file.is.dir <- function(name,remote) {
      cmd <- paste("test -d", name)
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(out = F, cmd) == 0
   }
   file.is.readable <- function(name,remote) {
      cmd <- paste("test -r", name)
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(out = F, cmd) == 0
   }
   file.cp.to <- function(name,remote) {
      if (remote != "")
         unix(paste("rcp ",name," ",remote,":",name,sep=""))
   }
   file.cp.from <- function(name,remote) {
      if (remote != "")
         unix(paste("rcp ",remote,":",name," ",name,sep=""))
   }
   if(length(sasin) != 1)
      stop("Illegal temporary file name")
   ok.dates <- c("sas", "yymmdd", "yearfrac", "yearfrac2")
   if(is.na(match(dates, ok.dates)))
      stop(paste("dates must be one of:", paste(ok.dates, collapse = 
         " ")))
   temp.files <- c(sasin, sasout1, sasout2)
   if(!keep.log)
      temp.files <- c(temp.files, log.file)
   if(clean.up) {
      clean.cmd <- paste("rm -f", paste(temp.files, collapse = " "))
      if (remote != "")
         clean.cmd <- paste(clean.cmd,";","rsh",remote,clean.cmd,"; date")
      on.exit(unix(clean.cmd))
   }
   if(missing(member))
      stop("SAS member name is required")
   if(missing(library))
      stop("SAS library name is required")
   cat(paste("%include '", macro.dir, "/", macro, "';\n", sep = ""), file
       = sasin)
   if(library == "") {
      cat("%", macro, "(", member, " ,", sasout1, " ,", sasout2, 
         ", dates=", dates, ", vars=", varstring, ", ifs=", ifs, 
         ");\n", file = sasin, append = T, sep = "")
   }
   else {
      if(!file.is.dir(library,remote))
         stop(paste(sep = "", "library, \"", library, 
            "\", is not a UNIX directory"))
      unix.file <- paste(sep = "", library, "/", member, ".ssd")
      unix.file2 <- file.find(unix.file,remote)
      if(!length(unix.file2)) {
         stop(paste(sep = "", "No UNIX files, \"", unix.file, 
            "*\""))
      }
      else if(length(unix.file2) > 1)
         stop(paste(sep = "", "More than one file in, \"", 
            unix.file, "*\""))
      else unix.file <- unix.file2
      if(!file.is.readable(unix.file,remote)) {
         stop(paste(sep = "", 
            "You do not have read permission for UNIX file, \"",
            unix.file, "\""))
      }
      cat("libname temp '", library, "';\n", file = sasin, append = T,
         sep = "")   #
# format.library should contain formats.sct containing user defined
# formats used by this dataset.  It must be present, but will not
# be used now.  Sigh.
#
      cat("libname library '", format.library, "';\n", file = sasin, 
         append = T, sep = "")
      cat("%", macro, "(temp.", member, " ,", sasout1, " ,", sasout2, 
         ", dates=", dates, ", vars=", varstring, ", ifs=", ifs, 
         ");\n", file = sasin, append = T, sep = "")
   }
   cmd <- paste("sas", sasin, "-log", log.file)
   if (remote != "")
      cmd <- paste("rsh",remote,cmd)
   file.cp.to(sasin,remote)
   status <- unix(cmd, output = F)
   file.cp.from(log.file,remote)
   if(status != 0) {
      if(!quiet)
         page(file = log.file)
      stop(paste("SAS job failed with status", status))
   }
#
# Read in the variable information
#
   if(!(file.exists(sasout1,remote) && file.exists(sasout2,remote))) {
      if(!quiet)
         page(file = log.file)
      stop("SAS output files not found")
   }
   file.cp.from(sasout1,remote)
   file.cp.from(sasout2,remote)
   vars <- scan(sasout1, list(name = "", type = 0, length = 0, format = "",
      label = "", n = 0), multi.line = T, sep = "\022")
   nvar <- length(vars$name)
   if(nvar == 0) {
      if(!quiet)
         page(file = log.file)
      stop("First SAS output is empty")
   }
   nrow <- vars$n[1]   #n is the same for each variable
#
# Read the data in
#  We try to be clever about the variable type.  If SAS is character
#  use char of course.  If is numeric and length >4, use double.  If
#  numeric and length <4, use single.  We could also use the format to
#  choose further, if it consists of a number followed by a "."
#  can we safely assume integer.
#
   type <- ifelse(vars$type == 2, "character(nrow)", ifelse(vars$length < 
      5, "single(nrow)", "double(nrow)"))   #
# get rid of trailing blank on names
   vars$name <- unix("sed 's/ $//'", vars$name)
   inlist <- paste("\"", vars$name, "\"=", type, sep = "", collapse = ", "
      )
   inlist <- parse(text = paste("list(", inlist, ")"))   #
# Inlist would now be the size of the final data structure, if I had
# evaluated it.
#
# Read the data
   ds <- scan(sasout2, eval(inlist), sep = "\022", multi.line = T)
   if(length(ds) < nvariables) {
      m <- variables[is.na(match(variables, names(ds)))]
      if(length(m) > 0) {
         warning(paste(length(m), 
            "requested variables did not exist:", paste(
            "\"", m, "\"", sep = "", collapse = " "), 
            "\n\t(use rsas.contents())"))
      }
   }
   labeled <- (vars$label != " ")
   for(i in (1:nvar)[labeled])
      attr(ds[[i]], "label") <- vars$label[i]
   if(data.frame.out) {
# Splus 3.0
      if(missing(id)) id <- as.character(1:nrow)
      ds <- data.frame(ds, row.names = id)
# THE NA.STRINGS =CHARACTER(0) CAUSES PROBLEMS ON ALPHA PORT OF S
#      ds <- data.frame(ds, row.names = id, na.strings = character(0))
   }
   else {
# Splus 2.3
      if(!missing(id)) {
         if(is.character(id))
            id <- match(id, names(ds))
         if(!is.na(id)) {
            if(id < 1 || id > nvar)
              stop("argument id out of range")
            attr(ds, "id") <- ds[[id]]
         }
      }
   }
   ds
}

sas.fget <- function(base.name, var.file = paste(base.name, ".1", sep = ""),
   data.file = paste(base.name, ".2", sep = ""), id, data.frame.out =
   exists("data.frame", mode = "function"),remote="")
{
# just read the SAS output files generated by $SHOME/cmd/sas_get
   file.is.readable <- function(name,remote) {
      cmd <- paste("test -r", name)
      if(remote != "")
         cmd <- paste("rsh",remote,cmd)
      unix(out = F, cmd) == 0
   }
   file.cp.from <- function(name,remote) {
      if (remote != "")
         unix(paste("rcp ",remote,":",name," ",name,sep=""))
   }
#
# Read in the variable information
#
   if(!(is.file.readable(var.file,remote) && is.file.readable(data.file,remote))) {
      stop("SAS output files not found or not readable")
   }
   file.cp.from(var.file,remote)
   file.cp.from(data.file,remote)
   vars <- scan(var.file, list(name = "", type = 0, length = 0, format = 
      "", label = "", n = 0), multi.line = T, sep = "\022")
   nvar <- length(vars$name)
   if(nvar == 0) {
      stop("SAS variable file is empty")
   }
   nrow <- vars$n[1]   #n is the same for each variable
#
# Read the data in
#  We try to be clever about the variable type.  If SAS is character
#  use char of course.  If is numeric and length >4, use double.  If
#  numeric and length <4, use single.  We could also use the format to
#  choose further, if it consists of a number followed by a "."
#  can we safely assume integer.
#
   type <- ifelse(vars$type == 2, "character(nrow)", ifelse(vars$length < 
      5, "single(nrow)", "double(nrow)"))
   inlist <- paste(vars$name, "=", type, c(rep(",", length(vars$name) - 1),
      " "), collapse = " ")
   inlist <- parse(text = paste("list(", inlist, ")"))   #
# Inlist would now the size of the final data structure, if I had
# evaluated it.
#
# Read the data
   ds <- scan(data.file, eval(inlist), sep = "\022", multi.line = T)
   labeled <- (vars$label != " ")
   for(i in (1:nvar)[labeled])
      attr(ds[[i]], "label") <- vars$label[i]
   if(data.frame.out) {
# Splus 3.0
      if(missing(id)) id <- as.character(1:nrow)
      ds <- data.frame(ds, row.names = id)
# THE NA.STRINGS =CHARACTER(0) CAUSES PROBLEMS ON ALPHA PORT OF S
#      ds <- data.frame(ds, row.names = id, na.strings = character(0))
   }
   else {
# Splus 2.3
      if(!missing(id)) {
         if(is.character(id))
            id <- match(id, names(ds))
         if(!is.na(id)) {
            if(id < 1 || id > nvar)
              stop("argument id out of range")
            attr(ds, "id") <- ds[[id]]
         }
      }
   }
   ds
}

From yandell@stat.wisc.edu Tue Feb 15 12:58:31 1994
Received: from mercury.stat.wisc.edu (mercury.stat.wisc.edu [128.105.5.39]) by biostat.mc.duke.edu (8.6.4/8.6.4) with SMTP id MAA00416 for <feh@biostat.mc.duke.edu>; Tue, 15 Feb 1994 12:58:26 -0500
Date: Tue, 15 Feb 94 11:58:21 -0600
From: yandell@stat.wisc.edu (Brian Yandell)
Message-Id: <9402151758.AA29829@mercury.stat.wisc.edu>
Received: by mercury.stat.wisc.edu; Tue, 15 Feb 94 11:58:21 -0600
To: Frank Harrell <feh@biostat.mc.duke.edu>
In-Reply-To: <199402151734.MAA22321@biostat2.mc.duke.edu>
Subject: Re: remote sas in S
Content-Length: 1247
X-Lines: 40
Status: RO

.BG
.FN sas
.TL
Remote Access to SAS Datasets
.CS
rsas.datasets(library,remote="atlas")
rsas.contents(library,member,...,remote="atlas")
rsas.get(library,member,variables,...,remote="atlas")
rsas.fget(base.name,...,remote="atlas")
.PP
Determine SAS datasets and their contents.
Get SAS dataset imported as S file.
Default setup assumes SAS can be found on a remote machine
(currently `atlas' at UW Stat Dept).
.SH NOTE
These functions require user to have SAS library (e.g. "saslib" below)
already set up on the SAS remote machine.
Consult SAS/BASE manuals for description of `libname' command.
.SH SAS LIBRARY
A permanent SAS library can be set up (while on the remote machine)
with the following SAS commands:
.nf

   /* create or use unix directory "saslib" as SAS library */
   /* tilde (~) places saslib directory in user's home directory */
   /* the internal name for this library is "lib" */
   libname lib '~/saslib';
   /* create permanent SAS dataset "mice" as file under "saslib" */
   data lib.mice;
      input dose ld50 strain lab_no;
      cards;
   \...
.SA
`sas.datasets', `sas.contents', `sas.get', `sas.fget'.
.EX
> rsas.datasets("saslib")
> rsas.contents("saslib","mice")
> mice <- rsas.get("saslib","mice")
.KW interface
.WR

From yandell@stat.wisc.edu Tue Feb 15 13:00:27 1994
Received: from mercury.stat.wisc.edu (mercury.stat.wisc.edu [128.105.5.39]) by biostat.mc.duke.edu (8.6.4/8.6.4) with SMTP id NAA00426 for <feh@biostat.mc.duke.edu>; Tue, 15 Feb 1994 13:00:25 -0500
Date: Tue, 15 Feb 94 12:00:24 -0600
From: yandell@stat.wisc.edu (Brian Yandell)
Message-Id: <9402151800.AA29869@mercury.stat.wisc.edu>
Received: by mercury.stat.wisc.edu; Tue, 15 Feb 94 12:00:24 -0600
To: Frank Harrell <feh@biostat.mc.duke.edu>
In-Reply-To: <199402151734.MAA22321@biostat2.mc.duke.edu>
Subject: Re: remote sas in S
Content-Length: 289
X-Lines: 8
Status: RO

Frank,
I just sent you the S source and a manual page (which I have installed
as both ?sas and ?rsas on our system).  Clearly, the rsas.* commands
have to be modified to fit local setup.  Let me know if you
incorporate this into the "official" release, or if you find serious
bugs.

Brian

