From s-sender@utstat.toronto.edu Mon Oct 24 09:34:29 1994
Received: from utstat.toronto.edu (utstat.toronto.edu [128.100.73.1]) by biostat.mc.duke.edu (8.6.8.1/8.6.6) with SMTP id JAA07326 for <feh@biostat.mc.duke.edu>; Mon, 24 Oct 1994 09:34:28 -0400
Received: by utstat; Mon Oct 24 09:16 EDT 1994
Received: from ficus (ficus [128.227.67.206]) by stat.ufl.edu (8.6.8.1/8.6.8) with ESMTP id JAA23734 for <s-news@utstat.toronto.edu>; Mon, 24 Oct 1994 09:16:16 -0400
Received: (longmate@localhost) by ficus (8.6.8.1/8.6.4) id JAA02738 for s-news@utstat.toronto.edu; Mon, 24 Oct 1994 09:16:14 -0400
Date: Mon, 24 Oct 1994 09:16:14 -0400
From: Jeff Longmate <longmate@Stat.UFL.Edu>
Message-Id: <199410241316.JAA02738@ficus>
To: s-news@utstat.toronto.edu
Subject: ternary, or triangular, diagrams
Status: RO


Robert G. (Bob) Garrett (garrett@gsc.emr.ca) writes:

> While I am here - I have another task coming up for myself.  Plotting  what 
> geoscientists and soil scientists call ternary, or triangular, diagrams.  If 
> any one has a function to plot these I would be grateful  for a copy. 

I wrote these a long while ago, so they could probably be tidied up.
They produce a "points out of bounds" message while drawing the triangle.

simplex.plot <-
 function(x, y, z, add=F, pch=par('pch'), labels=c('x','y','z'))
{
   # Plots proportions on a simplex.
   # Expects proportions summing to no more than 1 if two arguments given.
   # Normalizes if three arguments given.

        if(missing(z)) z <- 1 - (x+y)
        if(missing(y)) y <- 1 - (x+z)
        if(missing(x)) x <- 1 - (z+y)
        if(!(missing(x)|missing(y)|missing(z)))
          { s <- x+y+z
            x <- x/s
            y <- y/s
            z <- z/s
          }   
        d <- 1/sqrt(3)
        yy <- 1 - (y + z)
        xx <- (y - z)*d
        if(!add)
          { 
            xc <- c(0, d, -d)
            yc <- c(1, 0, 0)
            ylbl <- c(1.05,-0.05,-0.05)
            frame()
            par(usr=c(-d,d,(0.5-d),(0.5+d)),pty='s')
            polygon(xc,yc,density=0)
            for(i in 1:3) text(xc[i],ylbl[i],labels[i])
          }
        points(xx, yy, type = "p",pch=pch)
}

# ------------------------------------------

# SIMPLEX PLOT WITH ARROWS FOR CHANGES:
 
simplex.arrows <- function(x1, y1, z1, x2, y2, z2, 
                           add=F, pch=par('pch'), open=F,
                           labels=c('x','y','z'))
{
   if(missing(z1)) z1 <- 1 - (x1+y1)
   if(missing(y1)) y1 <- 1 - (x1+z1)
   if(missing(x1)) x1 <- 1 - (z1+y1)
   if(missing(z2)) z2 <- 1 - (x2+y2)
   if(missing(y2)) y2 <- 1 - (x2+z2)
   if(missing(x2)) x2 <- 1 - (z2+y2)
   if(!(missing(x1) | missing(y1) | missing(z1)))
     {
     s1 <- x1 + y1 + z1
     x1 <- x1/s1
     y1 <- y1/s1
     z1 <- z1/s1
     }
   if(!(missing(x2) | missing(y2) | missing(z2)))
     {
     s2 <- x2 + y2 + z2
     x2 <- x2/s2
     y2 <- y2/s2
     z2 <- z2/s2
     }
  d <- 1/sqrt(3)

  if(!add)
    {
    xc <- c(0, d, -d)
    yc <- c(1, 0, 0)
    ylbl <- c(1.05, -0.05, -0.05)
    frame()
    par(usr=c(-d,d,(0.5-d),(0.5+d)),pty='s')
    polygon(xc,yc,density=0)
    for(i in 1:3) text(xc[i],ylbl[i],labels[i])
    }
  yy1 <- 1 - (y1+z1) 
  xx1 <- (y1-z1)*d
  yy2 <- 1 - (y2+z2) 
  xx2 <- (y2-z2)*d

  arrows(xx1, yy1, xx2, yy2, pch=pch, open=open)
}



