

#   Version 1. 8/1/1995
#   tutor() is a menu-driven interactive program which provides an introductory
#   overview to many Splus functions and utilities. It provides near five 
#   hundred examples for illustration and allows the user to try their own
#   operations. Includes sections on Starting & Quitting Splus, On Line Help,
#   Data IN (read) & OUT (write) of Splus, Data (types, subscripting, combining)
#   in Splus, Arithmetic Operators, Relational Operators, Logical Operators,
#   Sequence & Repetition, Elementary Functions, Programming Functions,
#   Matrices & Sorting Functions, Character Data Operations, 
#   Reduction Operators & Simple Statistics, Statistical Distributions, 
#   Graphics, Statistical Analysis.

tutor <- function(){ 
    cat("Fu-Chuen Chang, changfc@math.nsysu.edu.tw\n")
    cat("Interactive program tutor to learn Splus version 3.1\n")
    cat("Version 1. released on 8/1/1995\n")
    top.names <- matrix(
c("start", "  Starting & Quitting Splus", "help", "  On Line Help", "in_out", 
	"  Data IN (read) & OUT (write) of Splus", "data", 
	"  Data (types, subscripting, combining) in Splus", "arithm", 
	"  Arithmetic Operators", "relation", "  Relational Operators", 
	"logical", "  Logical Operators", "seq", "  Sequence & Repetition", 
	"arithmf", "  Elementary Mathematical Functions", "prog", 
	" Programming Functions", "funms", " Matrices & Sorting Functions ", 
	"string", " Character Data Operations", "reduct", 
	" Reduction Operators & Simple Statistics", "dist", 
	" Statistical Distributions", "graph", " Graphics", "stat", 
	" Statistical Analysis")
                        ,ncol=2,byrow=T)
    fun.names <- matrix(
c("start", "Splus\t\t\t# Start Splus", "start", 
	"Splus -e\t\t\t# Start Splus with edit facility", "start", 
	"Splus BATCH infile outfile\t# Run Splus in batch mode", "start", 
	"q()\t\t\t\t# Exit Splus", "start", "Ctrl+d\t\t\t# Exit Splus", "start",
	"unix", "start", ".First", "start", ".Last", "help", "help", "help", 
	"topic", "help", "args", "help", "help.start", "in_out", "scan", 
	"in_out", "readline", "in_out", "read.table", "in_out", "source", 
	"in_out", "sink", "in_out", "cat", "in_out", "print", "in_out", "write",
	"in_out", "dput", "in_out", "dget", "in_out", "attach", "in_out", 
	"detach", "in_out", "library", "in_out", "search", "data", "c", "data", 
	"matrix", "data", "cbind", "data", "rbind", "data", "array", "data", 
	"list", "data", "data.frame", "data", "ts", "data", "category", "data", 
	"mode", "data", "length", "data", "names", "data", "dim", "data", 
	"nrow", "data", "ncol", "data", "dimnames", "data", "tsp", "data", 
	"attributes", "arithm", "*", "arithm", "+", "arithm", "-", "arithm", 
	"/", "arithm", "^", "arithm", "%%", "arithm", "%*%", "arithm", "%/%", 
	"arithm", "%o%", "relation", "!=", "relation", "<", "relation", "<=", 
	"relation", "==", "relation", ">", "relation", ">=", "logical", "!", 
	"logical", "|", "logical", "||", "logical", "&", "logical", "&&", "seq",
	"seq", "seq", "rep", "arithmf", "abs", "arithmf", "acos", "arithmf", 
	"acosh", "arithmf", "asin", "arithmf", "asinh", "arithmf", "atan", 
	"arithmf", "atanh", "arithmf", "ceiling", "arithmf", "cos", "arithmf", 
	"cosh", "arithmf", "exp", "arithmf", "floor", "arithmf", "gamma", 
	"arithmf", "lgamma", "arithmf", "log", "arithmf", "log10", "arithmf", 
	"max", "arithmf", "min", "arithmf", "pmax", "arithmf", "pmin", 
	"arithmf", "sin", "arithmf", "sinh", "arithmf", "sqrt", "arithmf", 
	"tan", "arithmf", "tanh", "arithmf", "trunc", "prog", "if", "prog", 
	"ifelse", "prog", "for", "prog", "repeat", "prog", "while", "prog", 
	"break", "prog", "next", "prog", "return", "funms", "chol", "funms", 
	"crossprod", "funms", "diag", "funms", "eigen", "funms", "outer", 
	"funms", "scale", "funms", "solve", "funms", "svd", "funms", "qr", 
	"funms", "apply", "funms", "t", "funms", "sort", "funms", "sort.list", 
	"funms", "order", "string", "grep", "string", "match", "string", 
	"nchar", "string", "paste", "string", "substring", "string", "parse", 
	"string", "eval", "reduct", "all", "reduct", "any", "reduct", "dim", 
	"reduct", "length", "reduct", "levels", "reduct", "max", "reduct", 
	"pmax", "reduct", "mean", "reduct", "median", "reduct", "mode", 
	"reduct", "min", "reduct", "pmin", "reduct", "prod", "reduct", 
	"quantile", "reduct", "range", "reduct", "sum", "reduct", "cumsum", 
	"reduct", "var", "reduct", "cor", "reduct", "stem", "dist", "Beta", 
	"dist", "Binomial", "dist", "Cauchy", "dist", "Chisquare", "dist", 
	"Exponential", "dist", "rf", "dist", "rgamma", "dist", "Geometric", 
	"dist", "Hypergeometric", "dist", "Logistic", "dist", "Lognormal", 
	"dist", "NegBinomial", "dist", "Normal", "dist", "Poisson", "dist", 
	"Stable", "dist", "rt", "dist", "Uniform", "dist", "Weibull", "dist", 
	"rwilcox", "dist", "sample", "dist", "set.seed", "graph", "X11", 
	"graph", "postscript", "graph", "par", "graph", "plot", "graph", 
	"lines", "graph", "points", "graph", "text", "graph", "abline", "graph",
	"qqplot", "graph", "qqnorm", "graph", "barplot", "graph", "boxplot", 
	"graph", "hist", "graph", "dotchart", "graph", "pie", "graph", 
	"contour", "stat", "lm", "stat", "stepwise", "stat", "leaps", "stat", 
	"demo")
                        ,ncol=2,byrow=T)
    eg.names <- matrix(
c("unix", "unix(\"date\")", "unix", "!ls     # Cannot call inside a function", 
	".First", ".First()", ".Last", ".Last()", "help", "help(\"stem\")", 
	"help", "?plot", "help", "?\"+\"", "topic", "topic(\"design\")", 
	"topic", "topic(\"plot\")", "args", "args(\"mean\")", "help.start", 
	"help.start()", "scan", "a_matrix(scan(n=4),nrow=2); a", "readline", 
	"a_readline(); a", "read.table", "'No example available'", "source", 
	"'No example available'", "sink", 
	"sink('xyz.splus'); print(1:10); sink(); !more xyz.splus", "cat", 
	"cat(rnorm(40),file='xyz.splus',fill=T); !more xyz.splus", "cat", 
	"x_1:6; cat('current x:', x, fill=T)", "cat", "cat('Now is:',date())", 
	"cat", "cat(1,2,3,4,5,6, fill=4, labels=letters[1:6])", "cat", 
	"cat(rnorm(40), fill=T, labels=c('odd string first','even string first'))",
	"cat", "x_matrix(1:6,2); cat(x)", "print", "x_matrix(1:6,2); print(x)", 
	"print", "x_1:6; print(x)", "write", 
	"write(sample(1:10,8),'xyz.splus'); !more xyz.splus", "dput", 
	"dput(sample(1:10,8),'xyz.splus'); !more xyz.splus", "dget", 
	"dput(sample(1:10,8),'xyz.splus'); dget('xyz.splus')", "data.dump", 
	"data.dump(sample(1:10,8),'xyz.splus'); !more xyz.splus", "library", 
	"library()", "library", "library(help=\"examples\")", "library", 
	"search()               #:)  Please go to the next example until 'over'",
	"library", 
	"library(examples); search()             #:)  continue the next example",
	"library", "detach(8); search()                     #:)  over", 
	"search", "search()", "c", "1:3 \t# Equivalent to c(1,2,3)", "c", 
	"c(2,4:5,7,11,a=31)", "c", "c(\"abc\",\"DEF\")", "c", "c(T,F,T,T)", "c",
	"a_c(2,4:5,7,11,a=31); a[2:4]", "c", "a_c(2,4:5,7,11,a=31); a[-(2:4)]", 
	"c", "a_c(2,4:5,7,11,a=31); a[a>7]", "c", 
	"a_c(2,4:5,7,11,a=31); a['a']", "c", "c(state.abb,\"Washington DC\")", 
	"c", "c(list(1:3,a=4:5),list(6:10))", "c", "c(c('a','b'),c('w','x'))", 
	"c", "a_matrix(1:6,nrow=2); b_matrix(0:-7,nrow=2); c(a,b)", "c", 
	"a_c(list(1:3,a=4:5),list(6:10)); a[[1]]", "matrix", "matrix(1:6,3)", 
	"matrix", "matrix(1:6,3)[2,]", "matrix", "matrix(1:6,3)[,1:2]", 
	"matrix", 
	"a_matrix(1:6,3,dimnames=list(c('a','b','c'),c('A','B'))); a[,'B']", 
	"matrix", "matrix(scan(n=4),ncol=2,byrow=T)", "cbind", 
	"x_matrix(1:50,10,5); cbind(x,matrix(1:20,10))", "rbind", 
	"x_matrix(1:50,10,5); rbind(x,1:5)", "array", 
	"array(1:12,c(2,3,2),list(c(\"a1\",\"a2\"),c(\"b1\",\"b2\",\"b3\"),c(\"c1\",\"c2\")))",
	"array", "array(1:12,c(2,3,2))[2,,]", "list", "list(letters,c(T,F,F))", 
	"list", "list(letters,c(T,F,F))[[2]]", "list", 
	"list(1:10,col=\"brown\",list(5:15,3:7,34:39))", "list", 
	"list(1:10,col=\"brown\",list(5:15,3:7,34:39))$col", "data.frame", 
	"data.frame(state.x77)", "data.frame", "data.frame(state.x77)[[1]]", 
	"data.frame", 
	"data.frame(pet=c(\"Dog\",\"Cat\",\"Unknown\"),age=c(34,40,10))", 
	"data.frame", 
	"data.frame(pet=c(\"Dog\",\"Cat\",\"Unknown\"),age=c(34,40,10))$pet", 
	"ts", "ts(1:120+rnorm(120),start=c(1960,6),frequency=12)", "ts", 
	"ts(1:120+rnorm(120),start=c(1960,6),frequency=12)[110:120]", 
	"category", "category(sample(c(\"T\",\"F\"),replace=T,size=8))", 
	"category", "cut(rnorm(10),4)", "category", "levels(cut(rnorm(10),4))", 
	"category", "table(sample(c(\"T\",\"F\"),replace=T,size=8))", 
	"category", "levels(state.region)", "mode", "mode(c())", "mode", 
	"mode(1:10)", "mode", "mode(sample(letters,5))", "mode", 
	"mode(list(1:5,c(\"A\",\"B\")))", "length", "length(runif(10))", 
	"length", "length(state.x77)", "length", "length(list(1:10,letters))", 
	"length", "length(data.frame(state.x77))", "names", 
	"names(list(a=1:4,b=runif(12)))", "names", "names(state.center)", "dim",
	"dim(matrix(runif(12),nrow=4))", "dim", 
	"dim(data.frame(1:26,letters,26:1))", "dim", 
	"dim(array(1:24,c(2,3,4)))", "nrow", "nrow(matrix(runif(12),nrow=4))", 
	"ncol", "ncol(matrix(runif(12),nrow=4))", "dimnames", 
	"dimnames(state.x77)", "tsp", "tsp(lynx)", "attributes", 
	"attributes(1:10)", "attributes", "attributes(state.x77)", "attributes",
	"attributes(data.frame(state.x77))", "*", "2*1:5", "*", "1:5*1:5", "*", 
	"c(1,3,5)*c(2,4,6)", "*", "c(5,3)*c(1,2,3)", "*", 
	"matrix(1:6,2)*c(1,10,100)", "*", "sqrt(2)*2.5", "+", "2+1:5", "+", 
	"1:5+1:5", "+", "c(1,3,5)+c(2,4,6)", "+", "c(5,3)+c(1,2,3)", "+", 
	"sqrt(2)+2.5", "-", "c(1.96,-23)-2", "-", "10-c(3.75,-9.1)", "-", 
	"5:10-1:6", "-", "c(100,85)-c(25,47)", "-", "c(2,4,6)-c(1,2)", "/", 
	"5.32/4.1", "/", "seq(0,80,length=11)/8", "/", 
	"c(56.8,72.9,15.6)/c(8,9,3)", "/", "matrix(1:6,2,byrow=T)/c(1,10,100)", 
	"/", "24/seq(2,8,2)", "/", "c(5.2,9.6)/3.2", "^", "0.2^-2", "^", 
	"-64^(1/3)", "^", "c(2,4,6)^c(4,2,3)", "^", "(1+5:8/2)^2", "%%", 
	"14%%5", "%%", "c(1.26,9.4)%%c(.25,3.2)", "%%", "10%%c(2,4.5,6)", "%*%",
	"c(1,2,3)%*%c(1,2,3)", "%*%", 
	"x_matrix(1:6,2,byrow=T);  t(x)%*%x     #equivalent to crossprod(x)", 
	"%*%", "matrix(1:6,2,byrow=T)%*%c(1,10,100)", "%/%", "10.8%/%2.5", 
	"%/%", "c(2.8,9,10.3)%/%c(0.5,2,5.1)", "%o%", "c(1,2,3)%o%c(1,2)", 
	"%o%", "c(1,2,3)%o%c(1,2,3)", "%o%", "c(1,10)%o%matrix(1:4,2,byrow=T)", 
	"%o%", "matrix(c(1,0,0,1),2,byrow=T)%o%matrix(1:4,2,byrow=T)", "!=", 
	"c(4,5,8) != c(5,5,7)", "!=", "c('ab','c')!=c('abs','c')", "!=", 
	"matrix(c(5,2,6,4),2,byrow=T)!=matrix(c(9,2,3,4),2,byrow=T)", "!=", 
	"x_seq(0,50,length=11); x[x !=25]", "<", "c(4,5,8) < c(5,5,7)", "<", 
	"c('a','b','ba','bas','bs','bsa','by','d') < c(rep('bs',8))", "<", 
	"matrix(c(5,2,6,4),2,byrow=T) < matrix(c(9,2,3,4),2,byrow=T)", "<", 
	"x_seq(0,50,length=11); x[x < 25]", "<=", "c(4,5,8) <= c(5,5,7)", "<=", 
	"c('a','b','ba','bas','bs','bsa','by','d') <= c(rep('bs',8))", "<=", 
	"matrix(c(5,2,6,4),2,byrow=T) <= matrix(c(9,2,3,4),2,byrow=T)", "<=", 
	"x_seq(0,50,length=11); x[x <= 25]", "==", "c(4,5,8) == c(5,5,7)", "==",
	"c('ab','c') == c('abs','c')", "==", 
	"matrix(c(5,2,6,4),2,byrow=T) == matrix(c(9,2,3,4),2,byrow=T)", "==", 
	"x_seq(0,50,length=11); x[x == 25]", ">", "c(4,5,8) > c(5,5,7)", ">", 
	"c('a','b','ba','bas','bs','bsa','by','d') > c(rep('bs',8))", ">", 
	"matrix(c(5,2,6,4),2,byrow=T) > matrix(c(9,2,3,4),2,byrow=T)", ">", 
	"x_seq(0,50,length=11); x[x > 25]", ">=", "c(4,5,8) >= c(5,5,7)", ">=", 
	"c('a','b','ba','bas','bs','bsa','by','d') >= c(rep('bs',8))", ">=", 
	"matrix(c(5,2,6,4),2,byrow=T) >=  matrix(c(9,2,3,4),2,byrow=T)", ">=", 
	"x_seq(0,50,length=11); x[x >= 25]", "!", "x_c(3,5,NA,9); x[!is.na(x)]",
	"!", "x_c('a','ha',9); x[!is.numeric(x)]", "|", 
	"x_array(seq(0,20,length=6),c(3,2));  x[x[,1]>4|x[,2]<=15]", "|", 
	"a <- c(T,F,NA); outer(a,a,'|')", "||", 
	"x_seq(-10,10); for(i in 1:length(x)) if(x[i]>=5 || x[i]<=-5)print(x[i])",
	"&", "x_seq(0,20,length=5); x[x>=5 & x<=15]", "&", 
	"x_array(seq(0,20,length=6),c(3,2)); x[x[,1]>=4&x[,2]<=18]", "&", 
	"a <- c(T,F,NA); outer(a,a,'&')", "&&", 
	"if(mode(x_3:6)!='character' && min(x)>0) log(x)", "seq", "seq(5)", 
	"seq", "5:1", "seq", "seq(-5)", "seq", "1.1:5", "seq", "seq(0,1,0.01)", 
	"seq", "seq(-pi,pi,length=100)", "seq", "seq(1,by=0.05,length=10)", 
	"seq", "seq(1,by=.05,along=1:5)", "rep", "rep(0,100)", "rep", 
	"rep(1:4,length=48)", "rep", "rep(1:10,10)", "rep", "rep(1:10,1:10)", 
	"rep", "rep(c(\"yes\",\"no\"),c(4,2))", "abs", "abs(c(-1,2.3,-4.2))", 
	"abs", "abs(matrix(rnorm(10), 2))", "acos", "acos(c(1/sqrt(2),1,-1))", 
	"acosh", "acosh(c(1,10))", "asin", "asin(c(0,1/2,1/sqrt(2)))", "asinh", 
	"asinh(c(0,1))", "atan", "atan(c(-1,1,sqrt(3)))", "atan", "atan(-1,1)", 
	"atan", "atan(1,-1)", "atanh", "atanh(c(0,0.5,1))", "ceiling", 
	"ceiling(c(0.99,12.3,-4.7))", "ceiling", "ceiling(seq(0,2,0.5))", 
	"ceiling", "ceiling(c(-1.9, -1.1, 1.1, 1.9))", "cos", 
	"cos(c(0,pi/4,-pi))", "cosh", "cosh(c(0,-5,5))", "exp", 
	"exp(c(0,1,-Inf))", "exp", "exp(log(2.7))", "floor", 
	"floor(c(0.99,12.3,-4.7))", "floor", "floor(seq(0,2,0.5))", "floor", 
	"floor(c(-1.9, -1.1, 1.1, 1.9))", "gamma", "gamma(seq(1,10,length=10))",
	"lgamma", "lgamma(seq(2,7,length=5))", "log", "log(exp(2))", "log", 
	"log(c(10,0.01),10)", "log", "log(2^seq(1,5),2)", "log", 
	"log(as.complex(-3))", "log10", "log10(c(10,0.01))", "sin", 
	"sin(c(0,pi/4,pi/2))", "sinh", "sinh(c(0,2,-2))", "sqrt", 
	"sqrt(c(100,2))", "sqrt", "sqrt(seq(1,5)^2)", "tan", 
	"tan(c(pi/4,0,pi/3))", "tan", 
	"1/tan(pi/3)            #cotangent of pi/3", "tanh", 
	"tanh(c(0,-10,10))", "trunc", "trunc(c(-1.5,1.5))", "trunc", 
	"trunc(c(-1.9, -1.1, 1.1, 1.9))", "if", 
	"if(mode(x_3:6)!=\"character\"&&min(x)>0)log(x)", "if", 
	"if(mode(x_-1:6)!=\"character\"&&min(x)>0)log(x)", "if", 
	"if(mode(x_3:6)!='character'&&min(x)>0) log(x) else x", "if", 
	"if(mode(x_c('a',3))!='character'&&min(x)>0) log(x) else x", "ifelse", 
	"log(ifelse((x_3:6)>0,x,NA))", "ifelse", "log(ifelse((x_-1:6)>0,x,NA))",
	"for", "for (i in 1:5) cat(i^2,'   ')", "for", 
	"for (x in letters[1:6]) cat(x,'  ')", "for", 
	"k1_k2_0; for (i in 1:10)  { k1_k1+i; k2_k2+i^2 } ; cat(k1,k2)", 
	"repeat", "j_k_0; repeat { if (j>10) break; k_k+j^2; j_j+1 }; k ", 
	"while", "k_0; while (k<=10) cat(k_k+2,'  ')", "while", 
	"j_k_0; while (j<=10) { k_k+j^2; j_j+1 }; k", "break", 
	"k_0; for (i in 1:10) {print(i); if ((k_k+i^2)>100) break}; cat(k)", 
	"break", "j_k_0; repeat {j_j+1; if ((k_k+j^2)>100) break}; k", "break", 
	"j_k_0; while(j<=10){j_j+1; if((k_k+j^2)>100) break}; k", "next", 
	"for (i in c(1,10,31,9,28)){if (i>10) next; cat(i,'  ')}", "return", 
	"x_function(y=5) {k_0; for(i in 0:20) if(i%%5==0) k_k+1; return(k*y)}; x()",
	"return", 
	"x_function(y=5) {k_0; for(i in 0:20) if(i%%5==0) k_k+1; return(k*y)}; x(10)",
	"chol", "a_matrix(runif(9),3,3); chol((a+t(a))/2)", "crossprod", 
	"crossprod(matrix(1:6,2,byrow=T))", "crossprod", 
	"crossprod(matrix(1:3,1,byrow=T),matrix(c(1,10),1,byrow=T))", 
	"crossprod", "crossprod(matrix(1:6,2),matrix(seq(0,30,10),2))", 
	"crossprod", "crossprod(matrix(c(1,1,2,3),2),matrix(1:6,2))", "diag", 
	"diag(matrix(runif(16),4,4))", "diag", "diag(1:5)", "eigen", 
	"eigen(matrix(runif(9),3,3))", "outer", "outer(1:4,1:3,\"*\")", "scale",
	"scale(matrix(runif(15),5,3))", "solve", 
	"solve(matrix(c(1,1,2,3),2),c(3,4))", "svd", 
	"svd(matrix(c(1,1,2,3),2))", "qr", "qr(matrix(c(1,1,2,3),2))", "apply", 
	"apply(state.x77,2,max)", "t", "t(matrix(c(1,1,2,3),2))", "sort", 
	"sort(runif(10))", "sort.list", "sort.list(runif(10))", "order", 
	"order(runif(10))", "grep", "state.name[ grep(\"ia$\", state.name) ]", 
	"grep", "state.name[ grep(\"ia$|^M\", state.name) ]", "grep", 
	"state.name[ grep(\"Ne*\", state.name) ]", "grep", 
	"state.name[ grep(\"Ne\", state.name) ]", "match", 
	"match(c(\"S\",\"p\",\"l\",\"u\",\"s\"),letters)", "nchar", 
	"nchar(state.name)", "paste", "paste(\"no.\",1:10)", "paste", 
	"paste(\"no.\",1:10,sep=\"\")", "paste", 
	"paste(state.name,\"pop =\",state.x77[,\"Population\"])", "substring", 
	"substring(state.name,1,8)", "substring", 
	"substring(state.name[1:10], 1, c(4,4,3,3,2,3,3,2,2,2))", "substring", 
	"substring(\"xxxxxxxxxx\",1,1:10)", "substring", 
	"substring(\"This is a test\",6)", "parse", 
	"a_c(\"min\",\"mean\",\"median\",\"max\"); for(i in a) print(parse(text=paste(i,\"(state.x77[,1])\"))) ",
	"eval", "a_c(\"min\",\"mean\",\"median\",\"max\"); for(i in a) {b_parse(text=paste(i,\"(state.x77[,1])\")); print(eval(b)) }",
	"all", "x_1:5;\tif(all(x>0)) x <- sqrt(x)", "all", 
	"x_-1:5; if(all(x>0)) x <- sqrt(x)", "any", 
	"x_rnorm(10); while (any(x<0)) x_x+abs(min(x)); x", "dim", 
	"dim(data.frame(x=1:4,y=runif(4)))", "dim", "dim(matrix(1:6,nrow=2))", 
	"dim", "dim(runif(10))", "dim", "dim(list(a=1,b=letters,c=1:5))", 
	"length", "z <- list(a=1,b=letters,c=1:5); length(z)", "length", 
	"z <- list(a=1,b=letters,c=1:5); length(z$c)", "length", 
	"length(data.frame(x=1:4,y=runif(4)))", "length", 
	"length(matrix(1:6,nrow=2))", "levels", "levels(state.region)", 
	"levels", "x_factor(rep(c(1,2),c(1,3))); levels(x)_LETTERS[1:2]; x", 
	"max", "max(-2.5,10.2)", "max", "max(c(5,-6),c(2,7,3))", "max", 
	"max(matrix(1:6,nrow=2))", "max", "max(-2.5,10.2,NA,na.rm=T)", "max", 
	"max(-2.5,10.2,NA)", "min", "min(-2.5,10.2)", "min", 
	"min(c(5,-6),c(2,7,3))", "min", "min(matrix(1:6,nrow=2))", "min", 
	"min(-2.5,10.2,NA,na.rm=T)", "min", "min(-2.5,10.2,NA)", "pmax", 
	"pmax(c(1,2,-5.6),c(-2.3,1,6),1.5)", "pmax", 
	"pmax(c(1,2,-5.6),c(-2.3,1,6),NA,na.rm=T)", "pmin", 
	"pmin(c(1,2,-5.6),c(-2.3,1,6),c(-1,4,0))", "pmin", 
	"pmin(c(1,2,-5.6),c(-2.3,1,6),0)", "pmin", 
	"pmin(c(1,2,-5.6),c(-2.3,1,6),NA,,na.rm=T)", "mean", "mean(runif(100))",
	"mean", "mean(rnorm(100))", "median", "median(runif(100))", "median", 
	"median(rnorm(100))", "mode", "mode(c(1,'ac'))", "mode", 
	"x_1:5; mode(x)_'complex'; x", "mode", "mode(matrix(1:6,nrow=2))", 
	"mode", "mode(list(a=1:5,b=letters[1:3]))", "prod", "prod(1:5)", "prod",
	"prod(1,5,10)", "quantile", "quantile(runif(100))", "quantile", 
	"quantile(runif(100),probs=seq(0,1,.2))", "range", "range(rnorm(100))", 
	"sum", "sum(1:10)", "cumsum", "cumsum(1:10)", "var", "var(rnorm(100))", 
	"var", "var(rnorm(10),rnorm(10))", "var", 
	"var(matrix(rnorm(10),nrow=2),matrix(rnorm(10),nrow=2))", "cor", 
	"cor(rnorm(10),rnorm(10))", "cor", 
	"cor(matrix(rnorm(10),nrow=2),matrix(rnorm(10),nrow=2))", "stem", 
	"stem(sample(50:100,size=50,replace=T))", "Normal", 
	"dnorm(c(1.1,sqrt(2)))", "Normal", "dnorm(1.1,0,10)", "Normal", 
	"pnorm(1.644854)", "Normal", "pnorm(1.644854,0,10)", "Normal", 
	"qnorm(0.95)", "Normal", "qnorm(0.95,0,10)", "Normal", "rnorm(20)", 
	"Normal", "rnorm(20,0,10)", "Beta", 
	"dbeta(c(0.4,sqrt(0.5)),c(0.5,1),2)", "Beta", "dbeta(seq(0,1,0.1),2,2)",
	"Beta", "pbeta(0.8,c(2,1),c(2,1))", "Beta", 
	"pbeta(qbeta(0.95,0.5,0.5),0.5,0.5)", "Beta", 
	"qbeta(pbeta(0.68,1,1),1,1)", "Beta", "rbeta(20,2,3)", "Beta", 
	"rbeta(5,c(2,10),c(1,12))", "Binomial", "dbinom(seq(0,100,10),100,0.9)",
	"Binomial", "dbinom(c(2,8),10,0.5)", "Binomial", 
	"pbinom(c(2,2.5,2.6),10,0.5)", "Binomial", 
	"pbinom(qbinom(0.91,10,0.5),10,0.5)", "Binomial", 
	"qbinom(c(0.5,0.55,0.7),10,0.5)", "Binomial", 
	"qbinom(pbinom(4.8,10,0.1),10,0.1)", "Binomial", "rbinom(20,10,0.5)", 
	"Binomial", "rbinom(10,c(20,100),c(0.1,0.5))", "NegBinomial", 
	"dnbinom(seq(2,10,2),100,0.5)", "NegBinomial", "dnbinom(c(2,8),10,0.5)",
	"NegBinomial", "pnbinom(c(2,2.5,2.6),10,0.5)", "NegBinomial", 
	"pnbinom(qnbinom(0.91,10,0.5),10,0.5)", "NegBinomial", 
	"qnbinom(c(0.5,0.55,0.7),10,0.5)", "NegBinomial", 
	"qnbinom(pnbinom(4.8,10,0.1),10,0.1)", "NegBinomial", 
	"rnbinom(20,10,0.5)", "NegBinomial", "rnbinom(20,c(10,20),c(0.2,0.5))", 
	"Cauchy", "dcauchy(c(1.1,sqrt(2)))", "Cauchy", 
	"dcauchy(1.1,c(0,5),c(10,20))", "Cauchy", "pcauchy(1,c(0,10))", 
	"Cauchy", "pcauchy(c(5,-5))", "Cauchy", "qcauchy(c(1/4,3/4))", "Cauchy",
	"qcauchy(pcauchy(c(5,-5)))", "Cauchy", "rcauchy(20)", "Cauchy", 
	"rcauchy(20,0,10)", "Chisquare", "dchisq(c(1.1,sqrt(2)),c(2,10))", 
	"Chisquare", "dchisq(seq(0,100,10),2)", "Chisquare", 
	"pchisq(c(2,2.5,2.6),c(2,5,10))", "Chisquare", 
	"pchisq(qchisq(0.5,2),2)", "Chisquare", "qchisq(0.5,2)", "Chisquare", 
	"qchisq(pchisq(c(0.95,0.6),c(2,10)),c(2,10))", "Chisquare", 
	"rchisq(10,2)", "Chisquare", "rchisq(10,c(2,10))", "Exponential", 
	"dexp(c(1.1,sqrt(2)))", "Exponential", "dexp(seq(0,100,10),2)", 
	"Exponential", "pexp(1,c(5.5,10))", "Exponential", 
	"pexp(qexp(0.5,2),2)", "Exponential", "qexp(c(0.5,1),1)", "Exponential",
	"qexp(pexp(c(0.95,0.6),c(2,10)),c(2,10))", "Exponential", 
	"values_seq(0.0001,6,length=200); values[values>qexp(.95)]", 
	"Exponential", "rexp(10,1/2)", "rf", "df(seq(0,6,length=10),4,12)", 
	"rf", "df(c(1.1,sqrt(2)),c(2,10),c(1,10))", "rf", 
	"pf(c(2,0.8),c(5,10),c(4,12))", "rf", "pf(qf(0.95,2,4),2,4)", "rf", 
	"qf(c(0.5,1),c(2,10),c(3,6))", "rf", 
	"qf(pf(c(1.57,100),c(2,10),5),c(2,10),5)", "rf", "rf(10,5,10)", 
	"rgamma", "dgamma(seq(0,6,length=10),4)", "rgamma", 
	"dgamma(c(1.1,sqrt(2)),c(2,10))", "rgamma", "pgamma(c(2,0.8),c(5,10))", 
	"rgamma", "pgamma(qgamma(0.95,2),2)", "rgamma", 
	"qgamma(c(0.5,0.72),c(4,12))", "rgamma", 
	"qgamma(pgamma(c(1.57,3.6),c(2,10)),c(2,10))", "rgamma", 
	"rgamma(20,10)", "Geometric", "dgeom(seq(0,6),0.5)", "Geometric", 
	"dgeom(c(5,2),c(0.2,0.5))", "Geometric", "pgeom(c(5,20),c(0.8,0.5))", 
	"Geometric", "pgeom(qgeom(0.95,0.01),0.01)", "Geometric", 
	"qgeom(c(0.25,0.75),0.05)", "Geometric", 
	"qgeom(pgeom(c(30,100),c(0.05,0.001)),c(0.05,0.001))", "Geometric", 
	"rgeom(20,0.01)", "Hypergeometric", "cumsum(dhyper(0:5,4,6,7))", 
	"Hypergeometric", "dhyper(rep(3,3),m=c(5,8,12),n=4,k=4)", 
	"Hypergeometric", "phyper(0:5,4,6,7)", "Hypergeometric", 
	"phyper(c(2,4),c(5,7),c(4,6),c(3,4))", "Hypergeometric", 
	"qhyper(c(0.5,0.75),c(5,7),c(4,6),c(3,4))", "Hypergeometric", 
	"qhyper(phyper(2,7,6,4),7,6,4)", "Hypergeometric", "rhyper(10,4,6,7)", 
	"Logistic", "dlogis(seq(0,6,length=10))", "Logistic", 
	"dlogis(c(-1.1,sqrt(2)),c(2,10),c(1,10))", "Logistic", 
	"plogis(c(1.2,-9,6),c(-5,10),c(1,2))", "Logistic", 
	"plogis(seq(0.1,0.3,0.01))", "Logistic", 
	"qlogis(c(0.5,0.8),c(-5,10),c(1,2))", "Logistic", 
	"qlogis(plogis(seq(0.1,0.3,0.01)))", "Logistic", "rlogis(10)", 
	"Logistic", "rlogis(10,-5,2)", "Lognormal", 
	"dlnorm(seq(0,6,length=10))", "Lognormal", 
	"dlnorm(c(1.1,sqrt(2)),c(2,10),c(1,10))", "Lognormal", 
	"plnorm(c(2,2.5,2.6),c(0.01,10,0),c(2,5,10))", "Lognormal", 
	"plnorm(qlnorm(0.8,0,4),0,4)", "Lognormal", "qlnorm(0.5,2)", 
	"Lognormal", "qlnorm(plnorm(c(1.57,100),c(2,10)),c(2,10))", "Lognormal",
	"rlnorm(5,0.01,1)", "Lognormal", "log(rlnorm(50))", "Poisson", 
	"dpois(1:10,5)", "Poisson", "dpois(c(1,10),c(2,5))", "Poisson", 
	"ppois(rep(3,2),c(5,10))", "Poisson", "ppois(qpois(0.8,2),2)", 
	"Poisson", "qpois(seq(0,1,0.1),2)", "Poisson", "rpois(20,3)", "Stable", 
	"rstab(20,2)", "Stable", "rstab(20,1.5,.5)", "rt", 
	"dt(seq(0,3,length=10),5)", "rt", "dt(rep(1:10,2),c(10,100))", "rt", 
	"pt(rep(0.76,2),c(5,100))", "rt", 
	"pt(qt(c(0.4,0.8),c(10,100)),c(10,100))", "rt", "qt(sqrt(0.4),c(5,50))",
	"rt", "qt(pt(c(-12.4,8.7),10),10)", "rt", "rt(20,2)", "Uniform", 
	"dunif(seq(0,1,0.1))", "Uniform", "dunif(1:3,0.5,pi)", "Uniform", 
	"punif(rep(5.5,2),c(2,4),c(8,10))", "Uniform", 
	"punif(qunif(c(0.4,0.8)))", "Uniform", 
	"qunif(sqrt(0.4),c(0,10),c(10,50))", "Uniform", 
	"qunif(punif(c(6.7,8.6),c(2,4),c(8,10)),c(2,4),c(8,10))", "Uniform", 
	"1+runif(10)", "Uniform", "runif(10,-1,1)", "Weibull", 
	"dweibull(1:8,.2)", "Weibull", "dweibull(c(pi,6),c(0.6,0.82))", 
	"Weibull", "pweibull(1:10,0.72)", "Weibull", 
	"pweibull(rep(3,2),c(0.5,0.9))", "Weibull", 
	"qweibull(sqrt(0.4),c(0.32,0.47))", "Weibull", 
	"qweibull(pweibull(rep(3,2),c(0.5,0.9)),c(0.5,0.9))", "Weibull", 
	"1:10+rweibull(10,.3)", "Weibull", "1+rweibull(10,0.95)", "rwilcox", 
	"dwilcox(50:52,9,3)", "rwilcox", "dwilcox(rep(18,2),c(4,2),c(6,13))", 
	"rwilcox", "pwilcox(c(8,24),c(2,6),c(4,8))", "rwilcox", 
	"pwilcox(60:65,6,19)", "rwilcox", "qwilcox(seq(0.1,0.2,0.05),4,6)", 
	"rwilcox", "qwilcox(pwilcox(5:10,2,4),2,4)", "rwilcox", 
	"rwilcox(10,3,6)", "rwilcox", "1:10+rwilcox(10,3,6)", "sample", 
	"sample(state.name,10)", "sample", "sample(1e6,20)", "sample", 
	"sample(50)", "sample", "sample(0:1,100,T,c(.3,.7))", "sample", 
	"sample(10,20,T)", "sample", 
	"sample(5,24,prob=c(.3,.4,.1,.1,.1),replace=T)", "set.seed", 
	"set.seed(153); runif(3)", "set.seed", "set.seed(13); runif(3)", "X11", 
	"X11(); readline(); dev.off() #graphics.off()", "postscript", 
	"postscript('plot.ps'); plot(corn.rain,corn.yield,type='l',lty=2); postscript()",
	"par", "par(mfrow=c(2,2)); plot(1:30); readline(); graphics.off()", 
	"plot", "plot(corn.rain,corn.yield,type=\"l\",lty=2)", "lines", 
	"plot(lottery.number,lottery.payoff); lines(100:900,seq(100,800,length=801))",
	"points", 
	"plot(rain.nyc1,type='b'); points(c(1880,1905),c(50,40),type='p')", 
	"text", "plot(rain.nyc1,type='b'); text(1880,55,'Rain Data')", "abline",
	"plot(rain.nyc1,type='b'); abline(0,1/40)", "qqplot", 
	"qqplot(rnorm(200),rnorm(200))", "qqplot", 
	"qqplot(rnorm(200),runif(200))", "qqnorm", "qqnorm(rbeta(200,2,10))", 
	"barplot", "a_barplot(b_sample(7:10,replace=T,size=10)); text(a,b,b)", 
	"boxplot", "boxplot(split(state.x77[,1],state.region))", "hist", 
	"hist(sample(7:10,replace=T,size=10))", "dotchart", 
	"dotchart(sample(7:10,replace=T,size=4))", "pie", 
	"pie(state.x77[1:5,1])", "contour", 
	"contour(-2:2,-2:2,matrix(-2:2%o%-2:2,nrow=5))", "lm", 
	"x_auto.stats[,'Weight']; y_auto.stats[,'Miles per gallon']; summary(lm(1/y~x))\t     # Fit linear regression model",
	"stepwise", 
	"stepwise(evap.x,evap.y,plot=F)   # Stepwise subset selection for multiple regression",
	"leaps", 
	"leaps(longley.x,longley.y)\t# All-Subset regression by leaps and bounds",
	"demo", "demo()")
                       ,ncol=2,byrow=T)
    device <- c("X11()","motif()","openlook()","x11()","win.graph()","vga()",
                "ega()","hercules()")

    EnterSplus <- function(){
	restart(T)
	repeat {cat("\n**  Enter expressions, q to quit from Splus session ",
                    "**\n\n")
		ans <- parse(prompt = "<P> ")
		if(is.name(ans[[1]]) && ans[[1]] == "q") return()
		print(eval(ans,local=sys.parent(1)))
	}  # end function repeat
    }  # end function EnterSplus

    descriptions <- c(top.names[,2])  # Start the main program
    while ({cat("\n\n_____________________________________________")
	    cat("\n\nEnter an item from the menu, 0 to exit tutorial program\n") 
	    (n1 <- menu(descriptions)) != 0 
    }) {if (top.names[n1,2] == " Graphics") {
            cat("\nEnter a graphic device available in your system\n")
            no <- menu(device)
            if (no == 0) break
            eval(parse(text=device[no]))
        }
	top.name <- top.names[top.names[,2] == descriptions[n1],1]
	funs <- fun.names[fun.names[,1] == top.name,2]
	while ({cat("\n\n_____________________________________________")
		cat("\n\nEnter an item from the menu, 0 to return main menu\n") 
		(n2 <- menu(funs)) != 0 
	}) {if (length(examples <- eg.names[eg.names[,1] == funs[n2],2]) > 0){
                cat("\n***************  menu for",funs[n2]," ***************\n")
                eval(parse(text=paste("?'",funs[n2],"'",sep="")))
                while ({cat("\n\n_____________________________________________")
                        cat(paste("\n\nEnter an item from the example menu for "
                            ,funs[n2],", 0 to return upper menu \n",sep=""))
                        (n3 <- menu(examples)) != 0
                }) {cat("\n    ",examples[n3],"\n\n")
                    print(eval(parse(text=examples[n3])))
                    test <- T
                    while (test){cat("\n\nDo you want to try something like",
                                     "this? (y/n/q)")
                                 ans <- readline()
                                 test <- ans != "y" && ans != "Y" && 
                                         ans != "n" && ans != "N" && 
                                         ans != "q" && ans != "Q"
                                 if (test) cat("\n>< Oops! Reenter y, n OR q !")
                    }  # end while (test)
                    if (ans == "q" || ans == "Q") break
                    if (ans == "y" || ans == "Y") EnterSplus()
                }  # end while ({cat("\n\n_______
            }  # end if (length(exam
            else{cat("\nHelp menu and examples are unavaible for this command!")
                 EnterSplus()
            }  # end else
        }  # end while ({cat("\n\n_____
	if (length(dev.list) != 0) graphics.off()
    }  # end while ({cat("\n\n________
   invisible()
}  #end function tutor

tutor()
